'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'                            RFM12 Empfangen (RX)  434
'                                                                     By DO1MAD
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
$regfile = "m32def.dat"
$crystal = 8000000                                          'interner Oszillator
$hwstack = 32
$swstack = 10
$framesize = 32
$baud = 19200

Print "RFM12 Empfangen"


'-------------------------Variablen setzen--------------------------------------
Dim Tx_word As Word
Dim Tx_l As Byte At Tx_word Overlay
Dim Tx_h As Byte At Tx_word + 1 Overlay
Dim Rx_word As Word
Dim Rx_l As Byte At Rx_word Overlay
Dim Rx_h As Byte At Rx_word + 1 Overlay
Dim Z As Byte
Dim Rxpuffer(18) As Byte At &H7E                            'Puffer in einen anderen Speicherbereich setzen
Dim Rxdaten As String * 18 At Rxpuffer(1) Overlay


'--------------Aliasse und Richtungen fr den RFM12 setzen----------------------
Cs Alias Portb.4 : Config Cs = Output : Set Cs
Sdi Alias Portb.5 : Config Sdi = Output
Sdo Alias Pinb.6 : Config Sdo = Input : Set Sdo
Sck Alias Portb.7 : Config Sck = Output
Ffit Alias Pind.3 : Config Ffit = Input
Config Portb.3 = Output : Set Portb.3                       'FSK pin auf hi ziehen
Led1 Alias Portd.6 : Config Led1 = Output
Led2 Alias Portd.5 : Config Led2 = Output



'------------------------LED's beim Programmstart testen------------------------
Set Led1
Waitms 500
Reset Led1
Set Led2
Waitms 500
Reset Led2

Print "Konfig SPI"


'--------------------ISP Schnittstelle konfigurieren----------------------------
Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1
Spiinit


'-------------------Auf Bereitschaft des RFM12 warten---------------------------
Waitms 300


'-------------------------RFM12 Initialisieren----------------------------------
Gosub Initialisation
Gosub Rfm12_bereit
Print "Ich bin jetzt auf Empfamg (434MHz)"
Goto 10                                                     'Es wird einmal beim Start der FIFO ausgelesen!
'-----------------------------Hauptschleife-------------------------------------


Do
If Ffit = 1 Then                                            'Prfen ob Daten im FIFO anliegen
Set Led1                                                    'Rote LED einschalten
10:                                                         'Starteinsprungspunkt
Tx_word = &HB000                                            'FIFO Auslesebefehl B000 in's TX-Word schreiben
Gosub Rfmwrite                                              'FIFO Auselesebefehl zum RFM12 senden
Incr Z                                                      'Z um 1 erhhen
Rxpuffer(z) = Rx_l                                          'Die Daten vom FIFO in den Puffer bertragen

If Rx_l = 0 Then                                            '0 ist das letzte Byte nach den Nutzdaten
Toggle Led2
Z = 0                                                       'Z fr die nchste bertragung zurcksetzten
Print Rxdaten                                               'Das empfangene Datenwort auf RS232 ausgeben

Rxdaten = ""                                                'Nutzdaten nach dem Senden rcksetzten
Gosub Rfm12_bereit                                          'Den Rfm12 fr den Empfang wieder bereit machen
Reset Led1                                                  'Rote LED ausschalten
End If
End If
Loop
'----------------------------Zum Chip schreiben---------------------------------
Rfmwrite:
Reset Cs
Rx_h = Spimove(tx_h)
Rx_l = Spimove(tx_l)
Set Cs
Return
'----------------------------Zum Empfang bereit machen--------------------------
Rfm12_bereit:
Tx_word = &HCA81                                            'FIFO Initialisieren
Gosub Rfmwrite
Tx_word = &HCA83                                            'FIFO Aktivieren
Gosub Rfmwrite
Return
'----------------Alle 14 Initialisationsdaten dem RFM12 bergeben---------------
Initialisation:
Restore Initialisationsdaten
For Z = 1 To 14
Read Tx_word
Gosub Rfmwrite
Waitms 30
Next
Return
'-------------------------------------------------------------------------------
Initialisationsdaten:                                       'Daten gem RFM12 Command Calculator
'-------------------------------------------------------------------------------
Data &H80D7%                                                'Configurations Settings Command
Data &H8298%                                                'Power Management Command
Data &HA668%                                                'Frequency Setting Command (HA668 = 434MHz)
Data &HC611%                                                'Data Rate Command
Data &H94A0%                                                'Receiver Control Command
Data &HC2AD%                                                'Data Filter Command
Data &HCA81%                                                'FIFO und Reset Mode Command
Data &HCED4%                                                'Synchron Pattern Command
Data &HC400%                                                'Automatic Frequecy Control Command
Data &H9854%                                                'TX Control Command
Data &HCC17%                                                'PLL Settings Command
Data &HE000%                                                'Wake-Up Timer Command
Data &HC800%                                                'Low Duty-Cycle Command
Data &HC000%                                                'Low Battery Detect & C CLK Command
'-------------------------------------------------------------------------------
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'                               Programm Ende
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

' Der ISM Bereich fr 70cm: 433,05 bis 434,79 MHz