'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'                            RFM12 Senden (TX) 434
'                                                                     By DO1MAD
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
$regfile = "m32def.dat"
$crystal = 8000000                                          'interner Oszillator
$hwstack = 32
$swstack = 10
$framesize = 32
$baud = 19200

Print "RFM12 Senden"


'----------------------Variablen setzen-----------------------------------------
Dim Tx_word As Word
Dim Tx_l As Byte At Tx_word Overlay
Dim Tx_h As Byte At Tx_word + 1 Overlay
Dim Rx_word As Word
Dim Rx_l As Byte At Rx_word Overlay
Dim Rx_h As Byte At Rx_word + 1 Overlay
Dim Z As Byte
Dim Sendepuffer(18) As Byte


'--------------Aliasse und Richtungen fr den RFM12 setzen----------------------
Cs Alias Portb.4 : Config Cs = Output : Set Cs
Sdi Alias Portb.5 : Config Sdi = Output
Sdo Alias Pinb.6 : Config Sdo = Input
Sck Alias Portb.7 : Config Sck = Output
Led1 Alias Portd.6 : Config Led1 = Output
Led2 Alias Portd.5 : Config Led2 = Output
Config Portb.3 = Output : Set Portb.3                       'FSK pin auf hi ziehen

'------------------------LED's beim Programmstart testen------------------------



Set Led1
Waitms 500
Reset Led1
Set Led2
Waitms 500
Reset Led2

Print "Konfig SPI"

'-----------------------SPI Port Configuration----------------------------------
Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , _
Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1
Spiinit


'-------------------------------------------------------------------------------
Waitms 300                                                  'Auf Bereitschaft des RFM12 warten!
'-------------------------------------------------------------------------------
Gosub Initialisation                                        'Zur Initialisation springen
'---------------------------Sendepuffer fllen----------------------------------
Sendepuffer(1) = &HAA                                       'Preamble an Modul bertragen
Sendepuffer(2) = &HAA                                       'Preamble an Modul bertragen
Sendepuffer(3) = &HAA                                       'Preamble an Modul bertragen
'--------------------
Sendepuffer(4) = &H2D                                       'HI Byte fr die Frame-Erkennung
Sendepuffer(5) = &HD4                                       'LO Byte fr die Frame-Erkennung
'--------------------
Sendepuffer(6) = "H"                                        'Nutzdaten Byte's
Sendepuffer(7) = "A"
Sendepuffer(8) = "L"
Sendepuffer(9) = "L"
Sendepuffer(10) = "O"
Sendepuffer(11) = " "
Sendepuffer(12) = "L"
Sendepuffer(13) = "E"
Sendepuffer(14) = "U"
Sendepuffer(15) = "T"
Sendepuffer(16) = "E"
'--------------------
Sendepuffer(17) = 0                                         'Kann man als String in der Empfangs-Software nutzen
'--------------------
Sendepuffer(18) = &HFF

Print "senden"                                              'Dummy Byte
'-------------------------------------------------------------------------------
'-------------------------------Hauptschleife-----------------------------------
Do
   Wait 1                                                   'Ein Durchlauf pro Sekunde
   Gosub Sender_an                                          'Senderendstufe einschalten
   Set Led1                                                 'Rote LED einschalten
   Gosub Bereit                                             'Auf Bereitschaft warten

   For Z = 1 To 18                                          'Sendepuffer 1 bis 18 abarbeiten
      Tx_word = &HB800 + Sendepuffer(z)                     'Sendekomando B800 und Pufferinhalt zusammenfhren
      Gosub Bereit                                          'Auf bereitschaft warten
      Gosub Rfmwrite                                        '1 Sendepuffer Byte bergeben
   Next Z                                                   'Nchsten Schleifendurchlauf

   Reset Led1                                               'Rote LED ausschalten
   Waitms 5                                                 'Dem RFM12 zeit zum senden lassen
   Gosub Sender_aus                                         'Senderendstufe abschalten
   Print "HALLO LEUTE gesendet!"
Loop
'-------------------------------------------------------------------------------
'--------------------------------SUB's------------------------------------------
Bereit:
   Reset Cs                                                 'RFM auswhlen
   Bitwait Sdo , Set                                        'Auf Highpegel warten
   Return
'-------------------------------------------------------------------------------
Rfmwrite:
   Reset Cs                                                 'RFM auswhlen
   Rx_h = Spimove(tx_h)                                     'Sendet und empfngt das HI Byte
   Rx_l = Spimove(tx_l)                                     'Sendet und empfngt das LO Byte
   Set Cs                                                   'RFM abwhlen
   Return
'-------------------------------------------------------------------------------
Initialisation:                                             'Initialisationsdaten zum RFM12 senden
   Restore Initialisationsdaten
   For Z = 1 To 14                                          'Alle 14 Kommando's abarbeiten
   Read Tx_word
   Gosub Rfmwrite                                           'Daten an RFM12 senden
   Waitms 30                                                'Zeit zum ausfhren der einzelnen Commando's geben
   Next                                                     '14x 30ms = 420ms Gesamtzeit
   Return
'-------------------------------------------------------------------------------
Initialisationsdaten:                                       'Daten gem RFM12 Command Calculator
'-------------------------------------------------------------------------------
Data &H80D7%                                                'Configurations Settings Command
Data &H8238%                                                'Power Management Command
Data &HA668%                                                'Frequency Setting Command (HA668 = 434MHz)
Data &HC611%                                                'Data Rate Command
Data &H94A0%                                                'Receiver Control Command
Data &HC2AD%                                                'Data Filter Command
Data &HCA81%                                                'FIFO und Reset Mode Command
Data &HCED4%                                                'Synchron Pattern Command
Data &HC400%                                                'Automatic Frequecy Control Command
Data &H9854%                                                'TX Control Command
Data &HCC17%                                                'PLL Settings Command
Data &HE000%                                                'Wake-Up Timer Command
Data &HC800%                                                'Low Duty-Cycle Command
Data &HC000%                                                'Low Battery Detect & C CLK Command
'-------------------------------------------------------------------------------
Sender_an:
   Restore Sender_an_daten
   Read Tx_word
   Gosub Rfmwrite                                           'Daten an RFM12 senden
   Waitms 30                                                'Zeit zum ausfhren der einzelnen Commando's geben
   Return
'-------------------------------------------------------------------------------
Sender_an_daten:                                            'Daten gem RFM12 Command Calculator
'-------------------------------------------------------------------------------
Data &H8238%                                                'Power Management Command                             'Low Battery Detect & C CLK Command
'-------------------------------------------------------------------------------
Sender_aus:
   Restore Sender_aus_daten
   Read Tx_word
   Gosub Rfmwrite                                           'Daten an RFM12 senden
   Waitms 30                                                'Zeit zum ausfhren der einzelnen Commando's geben
   Return
'-------------------------------------------------------------------------------
Sender_aus_daten:                                           'Daten gem RFM12 Command Calculator
'-------------------------------------------------------------------------------
Data &H8200%                                                'Power Management Command                             'Low Battery Detect & C CLK Command
'-------------------------------------------------------------------------------
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'                               Programm Ende
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

' Der ISM Bereich fr 70cm: 433,05 bis 434,79 MHz